# -*- coding:utf-8 -*-

# criptname = ConfigParser
# version   = '0.01(0)'
# author__  = 'masa'
# copyright = 'masa 2014'
# web = "http://masaland.cocolog-nifty.com/"
#

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""

import sys, os, os.path
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import e32
import re


class NoSectionError:
    """設定エラー"""
    def __init__(self):
        pass


class NoOptionError:
    """設定エラー"""
    def __init__(self):
        pass


class ConfigParser:
    def __init__(self):
        self.Cfg_dic  = {} #{section name1:[line1,line2,,,], , ,}
        self.Key_list = [] #[section name1, section name2, ,,,]


    def read(self, read_file):
        # read_file: file path of config data 
        self.Cfg_dic  = {} # out put object
        self.Key_list = [] # out put object

        try:
            F = open(read_file, 'r')
            ur_data = (F.read()).decode("UTF-8")
            F.close()
        except IOError:
            pass
        except:
            F.close()
            raise

        # section 行のアドレスを取り出す
        start_list = []
        f1 = unicode("\[[^\]]+?\]", "UTF-8")   #search [section]
        pattern1 = re.compile(f1, re.I)

        start_list = []
        find_list = pattern1.finditer(ur_data, 0)  #find all
        for x in find_list:  #call iter. and get result one by one
            r_p = x.start()                       #position
            start_list.append(r_p)
        start_list.sort()
        if start_list:
            if start_list[0] != 0:
                start_list.insert(0, 0)
            start_list.append(len(ur_data))
        else:
            start_list = [0, len(ur_data)]

        # セクション毎に切り出し
        data_list = []
        if len(start_list) > 1:
            for n in range(1, len(start_list)):
                data_list.append(ur_data[start_list[n-1]:start_list[n]])
        else: # may be bug
            raise
            return None
        # 切り出し終わり

        for data in data_list:
            lines = (data.strip(u"\n")).split(u"\n")
            if not lines:
                continue # never come here (if come ,may be bug)
            wk1 = re.findall(unicode("\[(.*?)\]", "UTF-8"), lines[0])
            if len(wk1) > 0 :
                u_section = wk1[0].strip()
                self.Key_list.append(u_section)
                if len(lines) > 1:
                    self.Cfg_dic[u_section] = lines[1:]
                else:
                    self.Cfg_dic[u_section] = []
            else:
                u_section = u"no section"
                self.Key_list.append(u_section)
                self.Cfg_dic[u_section] = lines[0:]
        return True



    def write(self, F):
        # F:already opened file object 
        data = ""
        for x in self.Key_list:
            data_line_list = self.Cfg_dic[x]
            if x == u"no section":
                pass
            else:
                if data:
                    data = data + ("\n\n[%s]\n") % x.encode("UTF-8")
                else: # first section, first dat
                    data = ("[%s]\n") % x.encode("UTF-8")
            for y in data_line_list :
                data = data + ("%s\n") % y.encode("UTF-8")

        try:
            F.write(data)
        except:
            pass



    def add_section(self, section):
        u_section = unicode(section, "UTF-8").strip()
        try:
            id = self.Key_list.index(u_section) # already exist
        except:
            # section not exist in CFG
            self.Key_list.append(u_section)
            self.Cfg_dic[u_section] = []
        return True



    def get(self, section, option):
        # self.Cfg_dic   {section name1:[line1,line2,,,], , ,}
        # self.Key_list  [section name1, section name2, ,,,]
        u_section = unicode(section, "UTF-8").strip()
        u_option  = unicode(option.lower(), "UTF-8").strip()

        try:
            id = self.Key_list.index(u_section)
        except:
            raise NoSectionError
            return False
        line_list = self.Cfg_dic[u_section][:]
        for line in line_list:
            data_list = []
            data_list = [x.strip() for x in line.split(u"=")] #if len(x)>0] never add
            if len(data_list) > 0 and data_list[0] == u_option:
                break
            else:
                continue
        else:
            raise NoOptionError
            return False
        if len(data_list) > 1:
            data = data_list[1].encode("UTF-8") 
        else:
            data = ""
        return  data # option value


    def set(self, section, option, data):
        u_section = unicode(section, "UTF-8").strip()
        u_option  = unicode(option.lower(), "UTF-8").strip()
        u_data    = unicode(str(data), "UTF-8").strip()

        try:
            id = self.Key_list.index(u_section) # already exist?
        except:
            # section not exist in CFG
            raise NoSectionError
            return False
#            self.add_section(section)
        line_list = self.Cfg_dic[u_section][:]
        for i in range(len(line_list)):
            line = line_list[i]
            data_list = []
            data_list = [x.strip() for x in line.split(u"=")] #if len(x)>0] never add
            if len(data_list) > 0 and data_list[0] == u_option:
                break
            else:
                continue
        else:
            line_list.append(u" ") # dummy
            i = len(line_list) - 1 # i pointing to dummy
#        wk_data = unicode("%s = %s", "UTF-8") % (option.lower(), data)
        wk_data = u_option + u" = " + u_data
        line_list[i] = wk_data
        self.Cfg_dic[u_section] = line_list[:]
        return True


def main():
    TEST_FILE = "E:\\Data\\Hiisi\\PyStation\\ConfigParserTest.cfg"
    cfg = ConfigParser()
    try:
        cfg.add_section("テスト０")
        cfg.set("テスト０", "オプション０", "データ０")
    except:
        print "add section/set error"

    try:
        cfg.set("テスト１", "オプション１", "データ１")
        print "set/no section undetected error"
    except NoSectionError:
        pass
    except:
        print "set to no section error"

    try:
        F = open(TEST_FILE, "w")
        cfg.write(F)
        F.close()
    except:
        print "cfg write error"

    try:
        cfg.read(TEST_FILE)
    except:
        print "cfg read error"

    try:
        wk0 = ""
        wk0 = cfg.get("テスト０", "オプション０")
        if wk0 != "データ０":
            print "cfg get data unmach error"
    except:
        print "cfg get error"

    try:
        wk0 = cfg.get("テスト０", "オプション１")
        print "no option undetected error"
    except (NoOptionError):
        pass
    except:
        print "no option detect error"

    try:
        wk0 = cfg.get("テスト１", "オプション０")
        print "no section undetected error"
    except (NoSectionError):
        pass
    except:
        print "no section detect error"

    try:
        os.remove(TEST_FILE)
    except:
        print "test file delete error"

    print "test end"


if __name__ == '__main__':
    main()

#    appuifw.app.set_exit()
#    sys.exit()
